﻿Drop Table If Exists test_low_fares, test_cob_offers, test_mappings;

Create Temp Table test_low_fares
(
	low_fares_row_id Int Not Null,
	last_modified_date Timestamp Without Time Zone Not Null,
	number_in_party Int Not Null,
	price Int Not Null
);

Create Temp Table test_cob_offers
(
	cob_offer_id int not null, 
	
	num_adults_searched int not null, 
	num_children_searched int not null, 
	num_infants_searched int not null, 
	
	supplier_code text not null, 
	
	central_offer_id int not null, 
	credential_set_id int not null, 
	last_updated timestamp without time zone NOT NULL
);

Create Temp Table test_mappings
(
	low_fares_row_id Int Not Null,
	credential_set_id Int Not Null,
	central_offer_id Int Not Null,
	cob_offer_id Int Null,
	needs_updating Boolean Null
);

Copy test_low_fares From 'low_fares.csv' With ( Format CSV );
Copy test_cob_offers From 'cob_offers.csv' With ( Format CSV );
Copy test_mappings From 'mappings.csv' With ( Format CSV );


Update
	test_mappings as LFM
Set
	cob_offer_id = CO.cob_offer_id,
	needs_updating = (LF.last_modified_date > CO.last_updated)
From
	test_low_fares as LF
Join
	test_cob_offers as CO
	 On CO.num_adults_searched   = LF.number_in_party 
	And CO.num_children_searched = 0 
	And CO.num_infants_searched  = 0
	And CO.supplier_code         = 'AMA'
Where 
	LFM.low_fares_row_id     = LF.low_fares_row_id
	
	And CO.central_offer_id  = LFM.central_offer_id 
	And CO.credential_set_id = LFM.credential_set_id 
	
	-- Only update those rows where we don't already know the cob_offer_id
	And LFM.cob_offer_id Is Null;



